Description

方伯伯有一天去参加一个商场举办的游戏。商场派了一些工作人员排成一行。每个人面前有几堆石子。说来也巧,位置在 i 的人面前的第 j 堆的石子的数量,刚好是 i 写成 K 进制后的第 j 位。
现在方伯伯要玩一个游戏,商场会给方伯伯两个整数 L,R。方伯伯要把位置在 [L, R] 中的每个人的石子都合并成一堆石子。每次操作,他可以选择一个人面前的两堆石子,将其中的一堆中的某些石子移动到另一堆,代价是移动的石子数量 * 移动的距离。商场承诺,方伯伯只要完成任务,就给他一些椰子,代价越小,给他的椰子越多。所以方伯伯很着急,想请你告诉他最少的代价是多少。
例如:10 进制下的位置在 12312 的人,合并石子的最少代价为:
1 * 2 + 2 * 1 + 3 * 0 + 1 * 1 + 2 * 2 = 9
即把所有的石子都合并在第三堆

Input

输入仅有 1 行,包含 3 个用空格分隔的整数 L,R,K,表示商场给方伯伯的 2 个整数,以及进制数

HINT

1 < =  L < =  R < =  10^15, 2 < =  K < =  20

Solution

说白了,这个题就是给了L~R的数,每个数的每个数位是一堆石子,把这堆石子合成一个位置,求总的最小代价。

法一:GZZ法

发现,对于一个数字P,假设钦定最终合并位置是p,

调整的时候,p向左移动一位,代价变化是p及右边所有的数位和-p左边所有数位和。

p向右移动一位,代价变化是p及左边所有数位和-p右边所有数位和。

设最优的位置的数字是x,位置是p,p左边数位和是a,右边是b

那么,一定有不等式:x+a-b>=0 ; x+b-a>=0 就是说,x不论往左往右移动,代价的变化总是增大的。

即:-x<=a-b<=x

所以,如果知道最终填的a-b,和x,p,就可以判断这个p位置填x是不是左边a,右边b的最优解了。

枚举p,x;

伪代码:(cnt是最高位,进制用m,填数用k)

for(p=1~cnt)

for(x=0~m-1)

for(i=cnt~1)

   for(a-b=-200~+200)

  设f[i][a-b][0/1]表示,填完第i位,a-b的值,有没有限制情况下,所有符合情况的数移动到p位置所花费的代价。

g[i][a-b][0/1]表示,f的方案数,即满足情况的数的个数,方便转移。

if(i==p){

    

    continue;

  }

for(k=0;k<m;k++){

    if(i<p)

    else

  }

 在i循环完之后,

 for(a-b=-200~+200)

if(-x<=a-b<x) ret+=f[1][a-b][0/1]

 注意这里是<=和<,因为可能一个数字有两个位置都是最优的合并位置,只能算一遍。

代码:

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N=;
const int M=;
const int fix=;
const int up=;
ll f[N][][];
ll g[N][][];
ll L,R;
int m;
ll ansl,ansr;
int a[N],cnt;
ll wrk(){
ll ret=;
for(int p=;p<=cnt;p++){
for(int x=;x<m;x++){
memset(f,,sizeof f);
memset(g,,sizeof g);
g[cnt+][fix][]=;
for(int i=cnt;i>=;i--){
for(int j=;j<=up;j++){
if(i==p){
if(x<a[i]){
if(g[i+][j][]) g[i][j][]+=g[i+][j][],f[i][j][]+=f[i+][j][];
if(g[i+][j][]) g[i][j][]+=g[i+][j][],f[i][j][]+=f[i+][j][];
}
else if(x==a[i]){
g[i][j][]+=g[i+][j][],f[i][j][]+=f[i+][j][];
g[i][j][]+=g[i+][j][],f[i][j][]+=f[i+][j][];
}
else{
g[i][j][]+=g[i+][j][],f[i][j][]+=f[i+][j][];
}
continue;
} for(int k=;k<m;k++){
if(i>p){//before
if(j+k>up) continue; if(k<a[i]){
g[i][j+k][]+=g[i+][j][],f[i][j+k][]+=f[i+][j][]+(i-p)*k*g[i+][j][];
g[i][j+k][]+=g[i+][j][],f[i][j+k][]+=f[i+][j][]+(i-p)*k*g[i+][j][];
}
else if(k==a[i]){
g[i][j+k][]+=g[i+][j][],f[i][j+k][]+=f[i+][j][]+(i-p)*k*g[i+][j][];
g[i][j+k][]+=g[i+][j][],f[i][j+k][]+=f[i+][j][]+(i-p)*k*g[i+][j][];
}
else{
g[i][j+k][]+=g[i+][j][],f[i][j+k][]+=f[i+][j][]+(i-p)*k*g[i+][j][];
}
}
else{//after
if(j-k<) continue; if(k<a[i]){
f[i][j-k][]+=f[i+][j][]+g[i+][j][]*(p-i)*k,g[i][j-k][]+=g[i+][j][];
f[i][j-k][]+=f[i+][j][]+g[i+][j][]*(p-i)*k,g[i][j-k][]+=g[i+][j][];
}
else if(k==a[i]){
f[i][j-k][]+=f[i+][j][]+g[i+][j][]*(p-i)*k,g[i][j-k][]+=g[i+][j][];
f[i][j-k][]+=f[i+][j][]+g[i+][j][]*(p-i)*k,g[i][j-k][]+=g[i+][j][];
}
else{
f[i][j-k][]+=f[i+][j][]+g[i+][j][]*(p-i)*k,g[i][j-k][]+=g[i+][j][];
}
}
}
}
}
for(int j=;j<=up;j++){
if((fix-x<=j)&&(j<x+fix)){
ret+=f[][j][]+f[][j][];
}
}
}
}
return ret;
}
int main(){
scanf("%lld%lld",&L,&R);
scanf("%d",&m);
L--;
cnt=;
while(L){
a[++cnt]=L%m;
L/=m;
}
if(cnt==){
ansl=;
}
else{
ansl=wrk();
} cnt=;
while(R){
a[++cnt]=R%m;
R/=m;
}
ansr=wrk();
printf("%lld",ansr-ansl);
}

法二:大众法。

直接钦定1号位置是最优位置,计算出来所有的总和ans

调整。

枚举位置p从2~cnt,表示要计算从p-1移动到p,会有多少个数的代价减少多少。

代价就是,sum(1,p-1)-sum(p,cnt)

设f[i][a-b][0/1]表示,第i位,这个sum的差值,有没有限制情况下,多少个数符合这个情况。

循环完一个p之后,

把a-b<0的f,ans-=(a-b)*f[i][a-b][0/1]

a-b>=0的不管。

这样进行cnt次,一定可以把所有的数移动到最优解的位置。

网上题解很多,代码就不贴了。(我也没写)

[SCOI2014]方伯伯的商场之旅的更多相关文章

  1. [BZOJ3598][SCOI2014]方伯伯的商场之旅(数位DP,记忆化搜索)

    3598: [Scoi2014]方伯伯的商场之旅 Time Limit: 30 Sec  Memory Limit: 64 MBSubmit: 449  Solved: 254[Submit][Sta ...

  2. 洛谷P3286 [SCOI2014]方伯伯的商场之旅

    题目:洛谷P3286 [SCOI2014]方伯伯的商场之旅 思路 数位DP dalao说这是数位dp水题,果然是我太菜了... 自己是不可能想出来的.这道题在讲课时作为例题,大概听懂了思路,简单复述一 ...

  3. 【bzoj3598】: [Scoi2014]方伯伯的商场之旅

    Description 方伯伯有一天去参加一个商场举办的游戏.商场派了一些工作人员排成一行.每个人面前有几堆石子.说来也巧,位置在 i 的人面前的第 j 堆的石子的数量,刚好是 i 写成 K 进制后的 ...

  4. 【数位DP】SCOI2014 方伯伯的商场之旅

    题目内容 方伯伯有一天去参加一个商场举办的游戏.商场派了一些工作人员排成一行.每个人面前有几堆石子. 说来也巧,位置在 \(i\) 的人面前的第 \(j\) 堆的石子的数量,刚好是 \(i\) 写成 ...

  5. bzoj3598 [Scoi2014]方伯伯的商场之旅

    数位dp,我们肯定枚举集合的位置,但是如果每次都重新dp的话会很麻烦,所以我们可以先钦定在最低位集合,dp出代价,然后再一步步找到正确的集合点,每次更改的代价也dp算就好了. #include < ...

  6. 2019.03.28 bzoj3598: [Scoi2014]方伯伯的商场之旅(带权中位数+数位dp)

    传送门 题意咕咕咕自己读吧挺简单的 思路: 由带权中位数的性质可以得到对于每个数放在每个二进制位的代价一定是个单调或者单峰函数,因此我们先把所有的数都挪到第一个位置,然后依次向右枚举峰点(极值点)把能 ...

  7. BZOJ.3598.[SCOI2014]方伯伯的商场之旅(贪心 数位DP)

    题目链接 先考虑,对于确定的一个数,怎样移动代价最少(或者移到哪个位置最优)? 假设我们都移到下标\(1\)位置(设集合点为\(1\)),那么移动到下标\(2\)与\(1\)相比代价差为:\(下标&l ...

  8. 【bzoj3598】 Scoi2014—方伯伯的商场之旅

    http://www.lydsy.com/JudgeOnline/problem.php?id=3598 (题目链接) 题意 Solution 原来这就是极水的数位dp,呵呵= =,感觉白学了.htt ...

  9. BZOJ3598 SCOI2014方伯伯的商场之旅(数位dp)

    看到数据范围就可以猜到数位dp了.显然对于一个数最后移到的位置应该是其中位数.于是考虑枚举移到的位置,那么设其左边和为l,左右边和为r,该位置数为p,则需要满足l+p>=r且r+p>=l. ...

随机推荐

  1. 20155209林虹宇Exp4 恶意代码分析

    Exp4 恶意代码分析 系统运行监控 使用schtasks指令监控系统运行 新建一个txt文件,然后将txt文件另存为一个bat格式文件 在bat格式文件里输入以下信息 然后使用管理员权限打开cmd, ...

  2. 20155307实验八 《网络对抗》 Web基础

    20155307实验八 <网络对抗> Web基础 实验过程 Web前端:HTML 使用netstat -aptn查看80端口是否被占用(上次实验设置为Apache使用80端口),如果被占用 ...

  3. HTML 中使 footer 始终处于页面底部

    通常在页面中,需要使页脚 footer 部分始终处于底部.当页面高度不够 100% 时, footer 处于页面最底部,当页面内容高于 100% 时,页脚元素可以被撑到最底部. 方法一:绝对定位 &l ...

  4. JQuery快速入门-Ajax

    一.AJAX概述 概念:AJAX = Asynchronous JavaScript and XML(异步的 JavaScript 和 XML). 优点:通过在后台与服务器进行少量数据交换,AJAX ...

  5. 设计模式 笔记 生成器(建造者)模式 Builder

    //---------------------------15/04/08---------------------------- //builder 生成器(建造者)模式---对象创建型模式 /* ...

  6. html元素双击事件触发机制猜想及疑惑

    今天有个同事遇到一个奇怪的问题,我照着他的代码做了一些简化写了这个demo <!DOCTYPE html> <html> <head> <style type ...

  7. Mvc4_@Styles.Render提高性能

    在页面上可以用@Styles.Render("~/Content/css") 来加载css 首先要在App_Start 里面BundleConfig.cs 文件里面 添加要包含的c ...

  8. linux AB web 性能测试工具

    ab(选项)(参数) 选项 -A:指定连接服务器的基本的认证凭据: -c:指定一次向服务器发出请求数: -C:添加cookie: -g:将测试结果输出为“gnuolot”文件: -h:显示帮助信息: ...

  9. 深入浅出etcd系列 – 心跳和选举

    作者:宝爷 校对:DJ 1.绪论 etcd作为华为云PaaS的核心部件,实现了PaaS大多数组件的数据持久化.集群选举.状态同步等功能.如此重要的一个部件,我们只有深入地理解其架构设计和内部工作机制, ...

  10. PAT甲题题解-1044. Shopping in Mars (25)-水题

    n,m然后给出n个数让你求所有存在的区间[l,r],使得a[l]~a[r]的和为m并且按l的大小顺序输出对应区间.如果不存在和为m的区间段,则输出a[l]~a[r]-m最小的区间段方案. 如果两层fo ...